from zeta.nn.modules._activations import (
    AccurateGELUActivation,
    ClippedGELUActivation,
    FastGELUActivation,
    GELUActivation,
    LaplaceActivation,
    LinearActivation,
    MishActivation,
    NewGELUActivation,
    PytorchGELUTanh,
    QuickGELUActivation,
    ReLUSquaredActivation,
)
from zeta.nn.modules.adaptive_conv import AdaptiveConv3DMod
from zeta.nn.modules.adaptive_layernorm import AdaptiveLayerNorm
from zeta.nn.modules.adaptive_rmsnorm import AdaptiveRMSNorm
from zeta.nn.modules.add_norm import add_norm
from zeta.nn.modules.audio_to_text import audio_to_text
from zeta.nn.modules.avg_model_merger import AverageModelMerger
from zeta.nn.modules.block_butterfly_mlp import BlockButterflyLinear, BlockMLP
from zeta.nn.modules.blockdiag_butterfly import (
    BlockdiagButterflyMultiply,
    BlockdiagMultiply,
    Sin,
    StructuredLinear,
    blockdiag_butterfly_multiply_reference,
    blockdiag_multiply_reference,
    blockdiag_weight_to_dense_weight,
    fftconv_ref,
    mul_sum,
)
from zeta.nn.modules.cnn_text import CNNNew
from zeta.nn.modules.combined_linear import CombinedLinear
from zeta.nn.modules.conv_mlp import Conv2DFeedforward
from zeta.nn.modules.convnet import ConvNet
from zeta.nn.modules.cross_modal_reparametization import (
    CrossModalReParametrization,
    CrossModalReparamLinear,
    build_cross_modal_reparam_linear,
    change_original_linear_to_reparam,
    cross_modal_ffn,
    reparameterize_aux_into_target_model,
)
from zeta.nn.modules.dense_connect import DenseBlock
from zeta.nn.modules.dual_path_block import DualPathBlock
from zeta.nn.modules.dynamic_module import DynamicModule
from zeta.nn.modules.dynamic_routing_block import DynamicRoutingBlock
from zeta.nn.modules.ether import Ether
from zeta.nn.modules.exo import Exo
from zeta.nn.modules.fast_text import FastTextNew
from zeta.nn.modules.feedback_block import FeedbackBlock
from zeta.nn.modules.feedforward import FeedForward
from zeta.nn.modules.feedforward_network import FeedForwardNetwork
from zeta.nn.modules.film import Film
from zeta.nn.modules.film_conditioning import FilmConditioning
from zeta.nn.modules.flex_conv import FlexiConv
from zeta.nn.modules.flexible_mlp import CustomMLP
from zeta.nn.modules.freeze_layers import (
    freeze_all_layers,
    set_module_requires_grad,
)
from zeta.nn.modules.fused_dropout_add import (
    fused_bias_dropout_add,
    fused_dropout_add,
    jit_bias_dropout_add,
    jit_dropout_add,
)
from zeta.nn.modules.fused_dropout_layernom import FusedDropoutLayerNorm
from zeta.nn.modules.fused_gelu_dense import FusedDenseGELUDense
from zeta.nn.modules.fusion_ffn import MMFusionFFN
from zeta.nn.modules.gated_residual_block import GatedResidualBlock
from zeta.nn.modules.gill_mapper import GILLMapper
from zeta.nn.modules.h3 import H3Layer
from zeta.nn.modules.highway_layer import HighwayLayer
from zeta.nn.modules.image_to_text import img_to_text
from zeta.nn.modules.img_or_video_to_time import image_or_video_to_time
from zeta.nn.modules.img_patch_embed import ImgPatchEmbed
from zeta.nn.modules.itca import IterativeCrossSelfAttention
from zeta.nn.modules.lang_conv_module import ConvolutionLanguageBlock
from zeta.nn.modules.laser import Laser
from zeta.nn.modules.layernorm import LayerNorm, l2norm
from zeta.nn.modules.leaky_relu import LeakyRELU
from zeta.nn.modules.log_ff import LogFF
from zeta.nn.modules.lora import Lora
from zeta.nn.modules.mbconv import (
    DropSample,
    MBConv,
    MBConvResidual,
    SqueezeExcitation,
)
from zeta.nn.modules.mlp import MLP
from zeta.nn.modules.mlp_mixer import MixerBlock, MLPBlock, MLPMixer
from zeta.nn.modules.mm_layernorm import MMLayerNorm
from zeta.nn.modules.mm_ops import text_to_twod, threed_to_text
from zeta.nn.modules.moe import MixtureOfExperts
from zeta.nn.modules.moe_router import MoERouter
from zeta.nn.modules.multi_input_multi_output import (
    DynamicInputChannels,
    DynamicOutputDecoder,
    MultiInputMultiModalConcatenation,
    MultiModalEmbedding,
    OutputDecoders,
    OutputHead,
    SplitMultiOutput,
)
from zeta.nn.modules.multi_scale_block import MultiScaleBlock
from zeta.nn.modules.nebula import Nebula
from zeta.nn.modules.nfn_stem import NFNStem
from zeta.nn.modules.norm_fractorals import NormalizationFractral
from zeta.nn.modules.norm_utils import PostNorm
from zeta.nn.modules.p_scan import PScan, pscan
from zeta.nn.modules.parallel_wrapper import Parallel
from zeta.nn.modules.patch_img import patch_img
from zeta.nn.modules.patch_video import patch_video
from zeta.nn.modules.perceiver_layer import PerceiverLayer
from zeta.nn.modules.poly_expert_fusion_network import MLPProjectionFusion
from zeta.nn.modules.polymorphic_activation import PolymorphicActivation
from zeta.nn.modules.polymorphic_neuron import PolymorphicNeuronLayer
from zeta.nn.modules.prenorm import PreNorm
from zeta.nn.modules.proj_then_softmax import FusedProjSoftmax
from zeta.nn.modules.pulsar import Pulsar
from zeta.nn.modules.pyro import hyper_optimize
from zeta.nn.modules.qformer import QFormer
from zeta.nn.modules.qkv_norm import qk_norm, qkv_norm

#######
from zeta.nn.modules.quantized_layernorm import QuantizedLN
from zeta.nn.modules.recursive_block import RecursiveBlock
from zeta.nn.modules.residual import Residual
from zeta.nn.modules.resnet import ResNet
from zeta.nn.modules.rms_norm import RMSNorm
from zeta.nn.modules.rnn_nlp import RNNL
from zeta.nn.modules.shufflenet import ShuffleNet
from zeta.nn.modules.sig_lip import SigLipLoss
from zeta.nn.modules.simple_attention import simple_attention
from zeta.nn.modules.simple_feedforward import SimpleFeedForward

######
from zeta.nn.modules.simple_mamba import Mamba, MambaBlock
from zeta.nn.modules.simple_res_block import SimpleResBlock
from zeta.nn.modules.skipconnection import SkipConnection
from zeta.nn.modules.slerp_model_merger import SLERPModelMerger

####
from zeta.nn.modules.space_time_unet import (
    ContinuousPositionBias,
    Downsample,
    FeedForwardV,
    PseudoConv3d,
    ResnetBlock,
    SpaceTimeUnet,
    SpatioTemporalAttention,
    Upsample,
)
from zeta.nn.modules.spatial_transformer import SpatialTransformer
from zeta.nn.modules.ssm import SSM, selective_scan, selective_scan_seq
from zeta.nn.modules.stoch_depth import StochDepth
from zeta.nn.modules.stochastic_depth import StochasticSkipBlocK
from zeta.nn.modules.subln import SubLN
from zeta.nn.modules.super_resolution import SuperResolutionNet
from zeta.nn.modules.swiglu import SwiGLU, SwiGLUStacked
from zeta.nn.modules.time_up_sample import TimeUpSample2x
from zeta.nn.modules.to_logits import to_logits
from zeta.nn.modules.token_learner import TokenLearner
from zeta.nn.modules.top_n_gating import TopNGating
from zeta.nn.modules.triple_skip import TripleSkipBlock
from zeta.nn.modules.u_mamba import UMambaBlock
from zeta.nn.modules.unet import Unet
from zeta.nn.modules.v_layernorm import VLayerNorm
from zeta.nn.modules.v_pool import DepthWiseConv2d, Pool
from zeta.nn.modules.video_autoencoder import CausalConv3d
from zeta.nn.modules.video_diffusion_modules import (
    AttentionBasedInflationBlock,
    ConvolutionInflationBlock,
    TemporalDownsample,
    TemporalUpsample,
)
from zeta.nn.modules.video_to_tensor import video_to_tensor, video_to_tensor_vr
from zeta.nn.modules.video_to_text import video_to_text
from zeta.nn.modules.visual_expert import VisualExpert
from zeta.nn.modules.vit_denoiser import (
    VisionAttention,
    VitTransformerBlock,
    posemb_sincos_2d,
    to_patch_embedding,
)
from zeta.nn.modules.ws_conv2d import WSConv2d
from zeta.nn.modules.yolo import yolo
from zeta.nn.modules.palo_ldp import PaloLDP
from zeta.nn.modules.relu_squared import ReluSquared
from zeta.nn.modules.scale_norm import ScaleNorm
from zeta.nn.modules.mr_adapter import MRAdapter
from zeta.nn.modules.sparse_moe import (
    Top2Gating,
    NormalSparseMoE,
    HeirarchicalSparseMoE,
)
from zeta.nn.modules.return_loss_text import (
    return_loss_text,
    calc_z_loss,
    max_neg_value,
    TextTokenEmbedding,
    dropout_seq,
    transformer_generate,
)
from zeta.nn.modules.patch_linear_flatten import (
    vit_output_head,
    patch_linear_flatten,
    cls_tokens,
    video_patch_linear_flatten,
)
from zeta.nn.modules.chan_layer_norm import ChanLayerNorm

from zeta.nn.modules.query_proposal import TextHawkQueryProposal
from zeta.nn.modules.pixel_shuffling import PixelShuffleDownscale
from zeta.nn.modules.kan import KAN
from zeta.nn.modules.layer_scale import LayerScale
from zeta.nn.modules.fractoral_norm import FractoralNorm
from zeta.nn.modules.kv_cache_update import kv_cache_with_update
from zeta.nn.modules.expand import expand
# from zeta.nn.modules.img_reshape import image_reshape
# from zeta.nn.modules.flatten_features import flatten_features
# from zeta.nn.modules.scaled_sinusoidal import ScaledSinuosidalEmbedding
# from zeta.nn.modules.scale import Scale
# from zeta.nn.modules.scalenorm import ScaleNorm
# from zeta.nn.modules.simple_rmsnorm import SimpleRMSNorm
# from zeta.nn.modules.gru_gating import GRUGating
# from zeta.nn.modules.shift_tokens import ShiftTokens
# from zeta.nn.modules.swarmalator import simulate_swarmalators
# from zeta.nn.modules.transformations import image_transform
# from zeta.nn.modules.squeeze_excitation import SqueezeExcitation
# from zeta.nn.modules.clex import Clex

__all__ = [
    "CNNNew",
    "CombinedLinear",
    "ConvNet",
    "DynamicModule",
    "Exo",
    "FastTextNew",
    "FeedForwardNetwork",
    "LayerNorm",
    "l2norm",
    "Lora",
    "MBConv",
    "MLP",
    "Pulsar",
    "Residual",
    "ResNet",
    "RMSNorm",
    "RNNL",
    "ShuffleNet",
    "simple_attention",
    "SpatialTransformer",
    "SubLN",
    "SuperResolutionNet",
    "TokenLearner",
    "yolo",
    "Ether",
    "Nebula",
    "AdaptiveConv3DMod",
    "TimeUpSample2x",
    "CausalConv3d",
    "SimpleResBlock",
    "SigLipLoss",
    "SimpleFeedForward",
    "Unet",
    "VisualExpert",
    "FeedForward",
    "SkipConnection",
    "LogFF",
    "PolymorphicNeuronLayer",
    "CustomMLP",
    "PolymorphicActivation",
    "PreNorm",
    "IterativeCrossSelfAttention",
    "ConvolutionLanguageBlock",
    "H3Layer",
    "MLPMixer",
    "LeakyRELU",
    "AdaptiveLayerNorm",
    "SwiGLU",
    "SwiGLUStacked",
    "ImgPatchEmbed",
    "DenseBlock",
    "HighwayLayer",
    "MultiScaleBlock",
    "FeedbackBlock",
    "DualPathBlock",
    "RecursiveBlock",
    "PytorchGELUTanh",
    "NewGELUActivation",
    "GELUActivation",
    "FastGELUActivation",
    "QuickGELUActivation",
    "ClippedGELUActivation",
    "AccurateGELUActivation",
    "MishActivation",
    "LinearActivation",
    "LaplaceActivation",
    "ReLUSquaredActivation",
    "TripleSkipBlock",
    "DynamicRoutingBlock",
    "GatedResidualBlock",
    "StochasticSkipBlocK",
    "QuantizedLN",
    "SLERPModelMerger",
    "AverageModelMerger",
    "AdaptiveRMSNorm",
    "MambaBlock",
    "Mamba",
    "Laser",
    "FusedDenseGELUDense",
    "FusedDropoutLayerNorm",
    "Conv2DFeedforward",
    "MLPBlock",
    "MixerBlock",
    "WSConv2d",
    "StochDepth",
    "NFNStem",
    "Film",
    "DropSample",
    "SqueezeExcitation",
    "MBConvResidual",
    "video_to_tensor",
    "video_to_tensor_vr",
    "FusedProjSoftmax",
    "TopNGating",
    "MoERouter",
    "PerceiverLayer",
    "UMambaBlock",
    "audio_to_text",
    "patch_video",
    "img_to_text",
    "video_to_text",
    "hyper_optimize",
    "to_patch_embedding",
    "posemb_sincos_2d",
    "VisionAttention",
    "VitTransformerBlock",
    "VLayerNorm",
    "Parallel",
    "DepthWiseConv2d",
    "Pool",
    "MixtureOfExperts",
    "FlexiConv",
    "MMLayerNorm",
    "MMFusionFFN",
    "PostNorm",
    "PScan",
    "pscan",
    "selective_scan",
    "selective_scan_seq",
    "SSM",
    "FilmConditioning",
    "qkv_norm",
    "qk_norm",
    "FeedForwardV",
    "ContinuousPositionBias",
    "PseudoConv3d",
    "SpatioTemporalAttention",
    "ResnetBlock",
    "Downsample",
    "Upsample",
    "SpaceTimeUnet",
    "patch_img",
    "threed_to_text",
    "text_to_twod",
    "jit_dropout_add",
    "fused_dropout_add",
    "jit_bias_dropout_add",
    "fused_bias_dropout_add",
    "blockdiag_butterfly_multiply_reference",
    "BlockdiagButterflyMultiply",
    "blockdiag_weight_to_dense_weight",
    "blockdiag_multiply_reference",
    "BlockdiagMultiply",
    "fftconv_ref",
    "mul_sum",
    "Sin",
    "StructuredLinear",
    "BlockButterflyLinear",
    "BlockMLP",
    "GILLMapper",
    "add_norm",
    "to_logits",
    "CrossModalReParametrization",
    "CrossModalReparamLinear",
    "cross_modal_ffn",
    "build_cross_modal_reparam_linear",
    "change_original_linear_to_reparam",
    "reparameterize_aux_into_target_model",
    "QFormer",
    "MLPProjectionFusion",
    "NormalizationFractral",
    "image_or_video_to_time",
    "TemporalDownsample",
    "TemporalUpsample",
    "ConvolutionInflationBlock",
    "AttentionBasedInflationBlock",
    "freeze_all_layers",
    "set_module_requires_grad",
    "MultiModalEmbedding",
    "MultiInputMultiModalConcatenation",
    "SplitMultiOutput",
    "OutputHead",
    "DynamicOutputDecoder",
    "DynamicInputChannels",
    "OutputDecoders",
    "PaloLDP",
    "ReluSquared",
    "ScaleNorm",
    "MRAdapter",
    "Top2Gating",
    "NormalSparseMoE",
    "HeirarchicalSparseMoE",
    "return_loss_text",
    "calc_z_loss",
    "max_neg_value",
    "TextTokenEmbedding",
    "dropout_seq",
    "transformer_generate",
    "patch_linear_flatten",
    "vit_output_head",
    "posemb_sincos_2d",
    "ChanLayerNorm",
    "cls_tokens",
    "video_patch_linear_flatten",
    "TextHawkQueryProposal",
    "PixelShuffleDownscale",
    "KAN",
    "LayerScale",
    "FractoralNorm",
    "kv_cache_with_update",
    "expand",
]
